﻿Imports ThinkGeo.MapSuite.Core
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.WebEdition

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If (Not Page.IsPostBack) Then
            Map1.CurrentExtent = New RectangleShape(-97.766, 30.291, -97.755, 30.286)
            Map1.BackgroundFillBrush = New GeoSolidBrush(GeoColor.FromArgb(255, 233, 232, 214))
            Map1.MapUnit = GeographyUnit.DecimalDegree

            Dim austinStreetsShapeLayer As ShapeFileLayer = New ShapeFileLayer(Server.MapPath("~\Austin\austinstreets.shp"))
            austinStreetsShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad1
            austinStreetsShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

            Dim austinStreetsLabelLayer As ShapeFileLayer = New ShapeFileLayer(Server.MapPath("~\Austin\austinstreets.shp"))
            austinStreetsLabelLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.LocalRoad1("FENAME")
            austinStreetsLabelLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
            austinStreetsLabelLayer.DrawingMarginPercentage = 100

            Map1.StaticLayers.Add("AustinStreetsShapeLayer", austinStreetsShapeLayer)
            Map1.StaticLayers.Add("AustinStreetsLabelLayer", austinStreetsLabelLayer)


            Dim inMemoryLayer = GetInmemoryLayer()
            Map1.DynamicLayers.Add("shapeLayer", inMemoryLayer)

        End If
    End Sub

    Private Function GetInmemoryLayer() As InMemoryLayer
        Dim WKTShape1 As String = "Polygon((-97.766 30.291, -97.760 30.290, -97.758 30.288, -97.766 30.291))"
        Dim WKTShape2 As String = "Polygon((-97.765 30.288, -97.758 30.285, -97.758 30.287, -97.765 30.288))"

        Dim inMemoryLayer As New InMemoryLayer()
        Dim feature1 As New Feature(WKTShape1)
        Dim feature2 As New Feature(WKTShape2)

        inMemoryLayer.Open()
        inMemoryLayer.FeatureSource.BeginTransaction()
        inMemoryLayer.FeatureSource.AddFeature(feature1)
        inMemoryLayer.FeatureSource.AddFeature(feature2)
        inMemoryLayer.FeatureSource.CommitTransaction()

        inMemoryLayer.Close()

        inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.GetSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black)
        inMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        Return inMemoryLayer
    End Function




    Protected Sub buttonEditShape_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonEditShape.Click
        Dim shapeLayer As InMemoryLayer = CType(Map1.DynamicLayers("shapeLayer"), InMemoryLayer)

        For Each key As String In shapeLayer.Features.Keys
            Dim feature As Feature = shapeLayer.Features(key)
            Map1.EditLayer.Features.Add(feature.Id, feature)
        Next key

        shapeLayer.Features.Clear()
        Map1.Mode = ModeType.EditShape
    End Sub

    Protected Sub btnSubmitChanges_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSubmitChanges.Click
        Dim shapeLayer As InMemoryLayer = CType(Map1.DynamicLayers("shapeLayer"), InMemoryLayer)

        For Each key As String In Map1.EditLayer.Features.Keys
            Dim feature As Feature = Map1.EditLayer.Features(key)
            shapeLayer.Features.Add(feature.Id, feature)
        Next key

        Map1.EditLayer.Features.Clear()
    End Sub
End Class